Index: Dev/trunk/src/client/qed-client/model/widgets/QuestionEditorPreviewItem.js
===================================================================
--- Dev/trunk/src/client/qed-client/model/widgets/QuestionEditorPreviewItem.js	(revision 502)
+++ Dev/trunk/src/client/qed-client/model/widgets/QuestionEditorPreviewItem.js	(revision 503)
@@ -33,10 +33,16 @@
                         lang.hitch(this, 'onToggleFold')));
             this.own(this.removeButton.on('click',
-                        lang.hitch(this, 'onDestroy')));
+                        lang.hitch(this, '_handleDestroy')));
             this.own(this.editButton.on('click',
                         lang.hitch(this, 'onToggleEdit')));
             this.showEdit();
         },
-        onDestroy: function() {},
+        _handleDestroy: function(evt) {
+            if ( !( this.disabled || this.readOnly ) ) {
+                this.emit('destroy');
+            }
+            if ( evt ) { event.stop(evt); }
+            return false;
+        },
         _getValueAttr: function(value) {
             if ( this._editing ) {
@@ -102,4 +108,6 @@
                 this.innerWidget = newWidget;
                 this.addChild(this.innerWidget);
+                this.innerWidget.set('readOnly',this.readOnly);
+                this.innerWidget.set('disabled',this.disabled);
                 this.titleNode.innerHTML = this.value.type+" [editing]";
                 domClass.replace(this.editButton.iconNode, "rftIconAccept", "rftIconEdit");
Index: Dev/trunk/src/client/qed-client/model/widgets/QuestionListView.js
===================================================================
--- Dev/trunk/src/client/qed-client/model/widgets/QuestionListView.js	(revision 502)
+++ Dev/trunk/src/client/qed-client/model/widgets/QuestionListView.js	(revision 503)
@@ -23,5 +23,5 @@
                 actions: {
                     "Remove" : {
-                        callback: lang.hitch(this, 'removeItem', id, true),
+                        callback: lang.hitch(this, '_handleRemove', id),
                         properties: {
                             blockButton: false,
@@ -44,4 +44,9 @@
             w.startup();
             return w;
+        },
+        _handleRemove: function(id) {
+            if ( !( this.readOnly || this.disabled ) ) {
+                this.removeItem(id,true);
+            }
         }
     });
Index: Dev/trunk/src/client/qed-client/pages/question.js
===================================================================
--- Dev/trunk/src/client/qed-client/pages/question.js	(revision 502)
+++ Dev/trunk/src/client/qed-client/pages/question.js	(revision 503)
@@ -30,7 +30,5 @@
             if ( this.object.publicationDate ) {
                 this.QuestionEditorToolkit.set('readOnly',true);
-                this.QuestionEditorToolkit.set('disabled',true);
                 this.contentList.set('readOnly',true);
-                this.contentList.set('disabled',true);
             }
         },
Index: Dev/trunk/src/client/qed-client/pages/response.js
===================================================================
--- Dev/trunk/src/client/qed-client/pages/response.js	(revision 502)
+++ Dev/trunk/src/client/qed-client/pages/response.js	(revision 503)
@@ -43,5 +43,5 @@
                              this.response._surveyRun.respondentCanDeleteOwnResponse);
             this.cancelButton.set('disabled',canDelete||false);
-            this.surveyWidget.set('disabled', false);
+            this.surveyWidget.set('readOnly', false);
         },
         _disableSubmit: function() {
@@ -49,5 +49,5 @@
             this.continueButton.set('disabled',true);
             this.cancelButton.set('disabled',true);
-            this.surveyWidget.set('disabled', true);
+            this.surveyWidget.set('readOnly', true);
         },
         _showInfo: function(html) {
Index: Dev/trunk/src/client/qed-client/pages/survey.js
===================================================================
--- Dev/trunk/src/client/qed-client/pages/survey.js	(revision 502)
+++ Dev/trunk/src/client/qed-client/pages/survey.js	(revision 503)
@@ -70,7 +70,5 @@
             if ( this.object.publicationDate ) {
                 this.propertiesForm.set('readOnly',true);
-                this.propertiesForm.set('disabled',true);
                 this.questionList.set('readOnly',true);
-                this.questionList.set('disabled',true);
             }
         },