Index: Dev/trunk/node_modules/grunt-contrib-coffee/package.json
===================================================================
--- Dev/trunk/node_modules/grunt-contrib-coffee/package.json	(revision 484)
+++ Dev/trunk/node_modules/grunt-contrib-coffee/package.json	(revision 516)
@@ -44,6 +44,4 @@
     "gruntplugin"
   ],
-  "readme": "# grunt-contrib-coffee [![Build Status](https://secure.travis-ci.org/gruntjs/grunt-contrib-coffee.png?branch=master)](http://travis-ci.org/gruntjs/grunt-contrib-coffee)\n\n> Compile CoffeeScript files to JavaScript.\n\n\n\n## Getting Started\nThis plugin requires Grunt `~0.4.0`\n\nIf you haven't used [Grunt](http://gruntjs.com/) before, be sure to check out the [Getting Started](http://gruntjs.com/getting-started) guide, as it explains how to create a [Gruntfile](http://gruntjs.com/sample-gruntfile) as well as install and use Grunt plugins. Once you're familiar with that process, you may install this plugin with this command:\n\n```shell\nnpm install grunt-contrib-coffee --save-dev\n```\n\nOnce the plugin has been installed, it may be enabled inside your Gruntfile with this line of JavaScript:\n\n```js\ngrunt.loadNpmTasks('grunt-contrib-coffee');\n```\n\n*This plugin was designed to work with Grunt 0.4.x. If you're still using grunt v0.3.x it's strongly recommended that [you upgrade](http://gruntjs.com/upgrading-from-0.3-to-0.4), but in case you can't please use [v0.3.2](https://github.com/gruntjs/grunt-contrib-coffee/tree/grunt-0.3-stable).*\n\n\n## Coffee task\n_Run this task with the `grunt coffee` command._\n\nTask targets, files and options may be specified according to the grunt [Configuring tasks](http://gruntjs.com/configuring-tasks) guide.\n### Options\n\n#### separator\nType: `String`\nDefault: linefeed\n\nConcatenated files will be joined on this string.\n\n#### bare\nType: `boolean`\n\nCompile the JavaScript without the top-level function safety wrapper.\n\n#### join\nType: `boolean`\nDefault: `false`\n\nWhen compiling multiple .coffee files into a single .js file, concatenate first.\n\n#### sourceMap\nType: `boolean`\nDefault: `false`\n\nCompile JavaScript and create a .map file linking it to the CoffeeScript source. When compiling multiple .coffee files to a single .js file, concatenation occurs as though the 'join' option is enabled. The concatenated CoffeeScript is written into the output directory, and becomes the target for source mapping.\n### Usage Examples\n\n```js\ncoffee: {\n  compile: {\n    files: {\n      'path/to/result.js': 'path/to/source.coffee', // 1:1 compile\n      'path/to/another.js': ['path/to/sources/*.coffee', 'path/to/more/*.coffee'] // compile and concat into single file\n    }\n  },\n\n  compileBare: {\n    options: {\n      bare: true\n    },\n    files: {\n      'path/to/result.js': 'path/to/source.coffee', // 1:1 compile\n      'path/to/another.js': ['path/to/sources/*.coffee', 'path/to/more/*.coffee'] // compile and concat into single file\n    }\n  },\n\n  compileJoined: {\n    options: {\n      join: true\n    },\n    files: {\n      'path/to/result.js': 'path/to/source.coffee', // 1:1 compile, identical output to join = false\n      'path/to/another.js': ['path/to/sources/*.coffee', 'path/to/more/*.coffee'] // concat then compile into single file\n    }\n  },\n\n  compileWithMaps: {\n    options: {\n      sourceMap: true\n    },\n    files: {\n      'path/to/result.js': 'path/to/source.coffee', // 1:1 compile\n      'path/to/another.js': ['path/to/sources/*.coffee', 'path/to/more/*.coffee'] // concat then compile into single file\n    }\n  },\n\n  glob_to_multiple: {\n    expand: true,\n    flatten: true,\n    cwd: 'path/to',\n    src: ['*.coffee'],\n    dest: 'path/to/dest/',\n    ext: '.js'\n  }\n}\n```\n\nFor more examples on how to use the `expand` API to manipulate the default dynamic path construction in the `glob_to_multiple` examples, see \"Building the files object dynamically\" in the grunt wiki entry [Configuring Tasks](http://gruntjs.com/configuring-tasks).\n\n## Release History\n\n * 2013-04-19âââv0.7.0âââPlace Sourcemaps at bottom of file Change extension for Sourcemaps from .maps to .js.map\n * 2013-04-18âââv0.6.7âââImproved error reporting\n * 2013-04-08âââv0.6.6âââFix regression with single-file compilation.\n * 2013-04-05âââv0.6.5âââImproved error reporting\n * 2013-03-22âââv0.6.4âââSourcemap support\n * 2013-03-19âââv0.6.3âââIncrease error logging verbosity.\n * 2013-03-18âââv0.6.2âââBump to CoffeeScript 1.6.2\n * 2013-03-18âââv0.6.1âââSupport `join` option\n * 2013-03-06âââv0.6.0âââBump to CoffeeScript 1.6 Support literate CoffeeScript extension coffee.md\n * 2013-02-25âââv0.5.0âââBump to CoffeeScript 1.5 Support literate CoffeeScript (.litcoffee)\n * 2013-02-15âââv0.4.0âââFirst official release for Grunt 0.4.0.\n * 2013-01-23âââv0.4.0rc7âââUpdating grunt/gruntplugin dependencies to rc7. Changing in-development grunt/gruntplugin dependency versions from tilde version ranges to specific versions. Bump coffeescript dependency to 1.4.\n * 2013-01-09âââv0.4.0rc5âââUpdating to work with grunt v0.4.0rc5. Switching to this.filesSrc api.\n * 2012-12-15âââv0.4.0aâââConversion to grunt v0.4 conventions. Remove experimental destination wildcards.\n * 2012-10-12âââv0.3.2âââRename grunt-contrib-lib dep to grunt-lib-contrib.\n * 2012-09-25âââv0.3.1âââDon't fail when there are no files.\n * 2012-09-24âââv0.3.0âââGlobal options depreciated.\n * 2012-09-10âââv0.2.0âââRefactored from grunt-contrib into individual repo.\n\n---\n\nTask submitted by [Eric Woroshow](http://ericw.ca/)\n\n*This file was generated on Fri Apr 19 2013 09:49:08.*\n",
-  "readmeFilename": "README.md",
   "contributors": [
     {
@@ -84,5 +82,11 @@
     }
   ],
+  "readme": "# grunt-contrib-coffee [![Build Status](https://secure.travis-ci.org/gruntjs/grunt-contrib-coffee.png?branch=master)](http://travis-ci.org/gruntjs/grunt-contrib-coffee)\n\n> Compile CoffeeScript files to JavaScript.\n\n\n\n## Getting Started\nThis plugin requires Grunt `~0.4.0`\n\nIf you haven't used [Grunt](http://gruntjs.com/) before, be sure to check out the [Getting Started](http://gruntjs.com/getting-started) guide, as it explains how to create a [Gruntfile](http://gruntjs.com/sample-gruntfile) as well as install and use Grunt plugins. Once you're familiar with that process, you may install this plugin with this command:\n\n```shell\nnpm install grunt-contrib-coffee --save-dev\n```\n\nOnce the plugin has been installed, it may be enabled inside your Gruntfile with this line of JavaScript:\n\n```js\ngrunt.loadNpmTasks('grunt-contrib-coffee');\n```\n\n*This plugin was designed to work with Grunt 0.4.x. If you're still using grunt v0.3.x it's strongly recommended that [you upgrade](http://gruntjs.com/upgrading-from-0.3-to-0.4), but in case you can't please use [v0.3.2](https://github.com/gruntjs/grunt-contrib-coffee/tree/grunt-0.3-stable).*\n\n\n## Coffee task\n_Run this task with the `grunt coffee` command._\n\nTask targets, files and options may be specified according to the grunt [Configuring tasks](http://gruntjs.com/configuring-tasks) guide.\n### Options\n\n#### separator\nType: `String`\nDefault: linefeed\n\nConcatenated files will be joined on this string.\n\n#### bare\nType: `boolean`\n\nCompile the JavaScript without the top-level function safety wrapper.\n\n#### join\nType: `boolean`\nDefault: `false`\n\nWhen compiling multiple .coffee files into a single .js file, concatenate first.\n\n#### sourceMap\nType: `boolean`\nDefault: `false`\n\nCompile JavaScript and create a .map file linking it to the CoffeeScript source. When compiling multiple .coffee files to a single .js file, concatenation occurs as though the 'join' option is enabled. The concatenated CoffeeScript is written into the output directory, and becomes the target for source mapping.\n### Usage Examples\n\n```js\ncoffee: {\n  compile: {\n    files: {\n      'path/to/result.js': 'path/to/source.coffee', // 1:1 compile\n      'path/to/another.js': ['path/to/sources/*.coffee', 'path/to/more/*.coffee'] // compile and concat into single file\n    }\n  },\n\n  compileBare: {\n    options: {\n      bare: true\n    },\n    files: {\n      'path/to/result.js': 'path/to/source.coffee', // 1:1 compile\n      'path/to/another.js': ['path/to/sources/*.coffee', 'path/to/more/*.coffee'] // compile and concat into single file\n    }\n  },\n\n  compileJoined: {\n    options: {\n      join: true\n    },\n    files: {\n      'path/to/result.js': 'path/to/source.coffee', // 1:1 compile, identical output to join = false\n      'path/to/another.js': ['path/to/sources/*.coffee', 'path/to/more/*.coffee'] // concat then compile into single file\n    }\n  },\n\n  compileWithMaps: {\n    options: {\n      sourceMap: true\n    },\n    files: {\n      'path/to/result.js': 'path/to/source.coffee', // 1:1 compile\n      'path/to/another.js': ['path/to/sources/*.coffee', 'path/to/more/*.coffee'] // concat then compile into single file\n    }\n  },\n\n  glob_to_multiple: {\n    expand: true,\n    flatten: true,\n    cwd: 'path/to',\n    src: ['*.coffee'],\n    dest: 'path/to/dest/',\n    ext: '.js'\n  }\n}\n```\n\nFor more examples on how to use the `expand` API to manipulate the default dynamic path construction in the `glob_to_multiple` examples, see \"Building the files object dynamically\" in the grunt wiki entry [Configuring Tasks](http://gruntjs.com/configuring-tasks).\n\n## Release History\n\n * 2013-04-19âââv0.7.0âââPlace Sourcemaps at bottom of file Change extension for Sourcemaps from .maps to .js.map\n * 2013-04-18âââv0.6.7âââImproved error reporting\n * 2013-04-08âââv0.6.6âââFix regression with single-file compilation.\n * 2013-04-05âââv0.6.5âââImproved error reporting\n * 2013-03-22âââv0.6.4âââSourcemap support\n * 2013-03-19âââv0.6.3âââIncrease error logging verbosity.\n * 2013-03-18âââv0.6.2âââBump to CoffeeScript 1.6.2\n * 2013-03-18âââv0.6.1âââSupport `join` option\n * 2013-03-06âââv0.6.0âââBump to CoffeeScript 1.6 Support literate CoffeeScript extension coffee.md\n * 2013-02-25âââv0.5.0âââBump to CoffeeScript 1.5 Support literate CoffeeScript (.litcoffee)\n * 2013-02-15âââv0.4.0âââFirst official release for Grunt 0.4.0.\n * 2013-01-23âââv0.4.0rc7âââUpdating grunt/gruntplugin dependencies to rc7. Changing in-development grunt/gruntplugin dependency versions from tilde version ranges to specific versions. Bump coffeescript dependency to 1.4.\n * 2013-01-09âââv0.4.0rc5âââUpdating to work with grunt v0.4.0rc5. Switching to this.filesSrc api.\n * 2012-12-15âââv0.4.0aâââConversion to grunt v0.4 conventions. Remove experimental destination wildcards.\n * 2012-10-12âââv0.3.2âââRename grunt-contrib-lib dep to grunt-lib-contrib.\n * 2012-09-25âââv0.3.1âââDon't fail when there are no files.\n * 2012-09-24âââv0.3.0âââGlobal options depreciated.\n * 2012-09-10âââv0.2.0âââRefactored from grunt-contrib into individual repo.\n\n---\n\nTask submitted by [Eric Woroshow](http://ericw.ca/)\n\n*This file was generated on Fri Apr 19 2013 09:49:08.*\n",
+  "readmeFilename": "README.md",
   "_id": "grunt-contrib-coffee@0.7.0",
-  "_from": "grunt-contrib-coffee@~0.7.0"
+  "dist": {
+    "shasum": "9eac2d9460fa3c8962c38cb83cfe658a2fc1c8c9"
+  },
+  "_from": "grunt-contrib-coffee@0.7.0",
+  "_resolved": "https://registry.npmjs.org/grunt-contrib-coffee/-/grunt-contrib-coffee-0.7.0.tgz"
 }