Index: Dev/trunk/grunt-tasks/svn-ignore.js
===================================================================
--- Dev/trunk/grunt-tasks/svn-ignore.js	(revision 474)
+++ Dev/trunk/grunt-tasks/svn-ignore.js	(revision 517)
@@ -6,41 +6,43 @@
 module.exports = function(grunt) {
 
-    grunt.registerMultiTask('svn-ignore',
-                            "Makes sure the specified source files are ignored in Subversion.",
-                            function(){
-        var done = this.async();
+    grunt.registerMultiTask(
+        'svn-ignore',
+        "Makes sure the specified source files are ignored in Subversion.",
+        function(){
+            var done = this.async();
 
-        var tasks = _.chain(this.filesSrc)
-                     .groupBy(path.dirname)
-                     .map(function(files, dir) {
-                         return _.partial(updateSvnIgnore,
-                                          dir,
-                                          _.chain(files)
-                                           .map(path.basename)
-                                           .sortBy(_.identity)
-                                           .value());
-                     })
-                     .value();
+            var tasks = _.chain(this.filesSrc)
+                         .groupBy(path.dirname)
+                         .map(function(files, dir) {
+                             return _.partial(updateSvnIgnore,
+                                              dir,
+                                              _.chain(files)
+                                               .map(path.basename)
+                                               .sortBy(_.identity)
+                                               .value());
+                         })
+                         .value();
 
-        grunt.util.async.series(tasks,function(error, results){
-            done(error);
+            grunt.util.async.series(tasks,function(error, results){
+                done(error);
+            });
         });
-    });
 
-    grunt.registerMultiTask('svn-ignore-clean',
-                            "Clean generated ignore sections in Subversion.",
-                            function(){
-        var done = this.async();
+    grunt.registerMultiTask(
+        'svn-ignore-clean',
+        "Clean generated ignore sections in Subversion.",
+        function(){
+            var done = this.async();
 
-        var tasks = _.chain(this.filesSrc)
-                     .map(function(file) {
-                         return _.partial(clearSvnIgnore, file);
-                     })
-                     .value();
+            var tasks = _.chain(this.filesSrc)
+                         .map(function(file) {
+                             return _.partial(clearSvnIgnore, file);
+                         })
+                         .value();
 
-        grunt.util.async.series(tasks,function(error, results){
-            done(error);
+            grunt.util.async.series(tasks,function(error, results){
+                done(error);
+            });
         });
-    });
 
     function updateSvnIgnore(dir,files,callback) {
@@ -123,31 +125,28 @@
     
     function readSvnIgnore(dir,callback) {
-        return svnCommand('svn',
-                          ['propget', 'svn:ignore', dir],
-                          callback);
+        return svn(['propget', 'svn:ignore', dir],
+                   callback);
     }
 
     function writeSvnIgnore(dir,ignore,callback) {
-        return svnCommand('svn',
-                          ['propset', 'svn:ignore', ignore, dir],
-                          callback);
+        return svn(['propset', 'svn:ignore', ignore, dir],
+                   callback);
     }
     
     function deleteSvnIgnore(dir,callback) {
-        return svnCommand('svn',
-                          ['propdel', 'svn:ignore', dir],
-                          callback);
+        return svn(['propdel', 'svn:ignore', dir],
+                   callback);
     }
     
-    function svnCommand(cmd,args,callback) {
+    function svn(args,callback) {
         grunt.util.spawn({
-            cmd: cmd,
+            cmd: 'svn',
             args: (args || [])
-        }, function(error, result, code) {
+        }, function(error, result) {
             if ( error ) {
                 callback(error);
-                return;
+            } else {
+                callback(null,result.stdout);
             }
-            callback(null,result.stdout);
         });
     }