Index: Dev/trunk/Gruntfile.js
===================================================================
--- Dev/trunk/Gruntfile.js	(revision 517)
+++ Dev/trunk/Gruntfile.js	(revision 518)
@@ -11,47 +11,63 @@
     grunt.registerTask('default', ['compile']);
     // development
-    grunt.registerTask('compile', ['path-check:svn'
-                                  ,'svn-ignore:compile'
-                                  ,'jshint:lint-sources'
-                                  ,'htmlhint:lint'
-                                  ,'coffeelint:lint'
-                                  ,'jsonlint:lint'
-                                //,'tv4:lint'
-                                  ,'less:compile'
-                                  ,'usebanner:generated-css'
-                                  ,'coffee:compile'
-                                  ,'usebanner:generated-js'
-                                  ,'jshint:lint-generated'
-                                //,'amd-check' // too smart about plugins, r.js can't find them
-                                  ]);
-    grunt.registerTask('run', ['path-check:foreman'
-                              ,'compile'
-                              ,'foreman:dev']);
-    grunt.registerTask('build', ['compile'
-                                ,'clean:build'
-                                ,'copy:build'
-                                ,'dojo:build'
-                                ]);
-    grunt.registerTask('run-build', ['path-check:foreman'
-                                    ,'build'
-                                    ,'foreman:build']);
-    grunt.registerTask('deploy', ['path-check:svn'
-                                 ,'path-check:git'
-                                 ,'svninfo'
-                                 ,'build'
-                                 ,'git_deploy:deploy']);
+    grunt.registerTask('compile',
+                       "Lint all sources and compile Coffee and LESS sources.",
+                       ['path-check:svn'
+                       ,'svn-ignore:compile'
+                       ,'jshint:lint-sources'
+                       ,'htmlhint:lint'
+                       ,'coffeelint:lint'
+                       ,'jsonlint:lint'
+                     //,'tv4:lint'
+                       ,'less:compile'
+                       ,'usebanner:generated-css'
+                       ,'coffee:compile'
+                       ,'usebanner:generated-js'
+                       ,'jshint:lint-generated'
+                     //,'amd-check' // too smart about plugins, r.js can't find them
+                       ]);
+    grunt.registerTask('run',
+                       "Compile and start the server locally with foreman.",
+                       ['path-check:foreman'
+                       ,'compile'
+                       ,'foreman:dev']);
+    grunt.registerTask('build',
+                       "Compile and make a Dojo build of the client (compress sources).",
+                       ['compile'
+                       ,'clean:build'
+                       ,'copy:build'
+                       ,'dojo:build'
+                       ]);
+    grunt.registerTask('run-build',
+                       "Make a build and start server from build locally with foreman.",
+                       ['path-check:foreman'
+                       ,'build'
+                       ,'foreman:build']);
+    grunt.registerTask('deploy',
+                       "Make a build and deploy it to Heroku.",
+                       ['path-check:svn'
+                       ,'path-check:git'
+                       ,'svninfo'
+                       ,'build'
+                       ,'git_deploy:deploy']);
     // database management
     grunt.registerTask('db-backup-cloud-to-dated-local',
+                       "Backup the Heroku database to a timestamped local database.",
                        ['path-check:heroku'
                        ,'heroku-config'
                        ,'http:db-backup-cloud-to-dated-local']);
     grunt.registerTask('db-pull-cloud-to-local',
+                       "Synchronize local database with the Heroku database (pull changes).",
                        ['path-check:heroku'
                        ,'heroku-config'
                        ,'http:db-pull-cloud-to-local']);
     grunt.registerTask('db-push-local-to-cloud',
+                       "Synchronize the Heroku database with the local database (push changes).",
                        ['path-check:heroku'
                        ,'heroku-config'
                        ,'http:db-push-local-to-cloud']);
+    grunt.registerTask('#',
+                       "---\nTASKS BELOW ARE INTERNAL AND SHOULD NOT USUALLY BE CALLED FROM THE COMMAND-LINE\n---",
+                       []);
 
     // FILES AND FOLDERS